=== debian/changelog ===
cgal (4.12-1build1) cosmic; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 17 Jul 2018 12:54:00 +0000

cgal (4.12-1) unstable; urgency=medium

  * New upstream release.
    - Separate flags used to compile the libraries from flags required by
      users of the libraries (Closes: #886670).
  * Add Suggests: libsuitesparse-dev for libcgal-demo.
  * Update Standards-Version to 4.1.4 (no changes needed).

 -- Joachim Reichel <reichel@debian.org>  Thu, 26 Apr 2018 18:29:52 +0200

cgal (4.12~beta1-1) unstable; urgency=medium

 -- Joachim Reichel <reichel@debian.org>  Thu, 01 Mar 2018 18:38:56 +0100

cgal (4.11.1-1) unstable; urgency=medium

  * New upstream release.
  * Fix FCBFS: Let dh_auto_configure pass cross toolchain flags to cmake.
    Thanks to Helmut Grohne for the patch (Closes: #883550).
  * Override wrong lintian warning about not installed examples.
  * Use debhelper compat version 11 (no changes needed).
  * Update Standards-Version to 4.1.3 (no changes needed).

 -- Joachim Reichel <reichel@debian.org>  Thu, 01 Mar 2018 18:34:40 +0100
